Package org.eclipse.lemminx.dom

## Class DOMDocumentType

- java.lang.Object
- - org.eclipse.lemminx.dom.DOMNode
  - - org.eclipse.lemminx.dom.DTDDeclNode
    - - org.eclipse.lemminx.dom.DOMDocumentType

All Implemented Interfaces:
  `DOMRange`, `DocumentType`, `Node`

    public class DOMDocumentType
    extends DTDDeclNode
    implements DocumentType

A doctype node.

### Nested Class Summary

Nested Classes
`static class` `DOMDocumentType.DocumentTypeKind`

### Field Summary

### Fields inherited from class org.eclipse.lemminx.dom.DTDDeclNode

`declType, unrecognized`

### Fields inherited from class org.eclipse.lemminx.dom.DOMNode

`DTD_ATT_LIST_NODE, DTD_DECL_NODE, DTD_ELEMENT_DECL_NODE, DTD_ENTITY_DECL_NODE, DTD_NOTATION_DECL, NULL_VALUE`

### Fields inherited from interface org.w3c.dom.Node

`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

### Constructor Summary

Constructors
`DOMDocumentType​(int start, int end)`

### Method Summary

All Methods Instance Methods Concrete Methods
`NamedNodeMap` `getEntities()`
`String` `getInternalSubset()`
`DTDDeclParameter` `getInternalSubsetNode()` Returns the declaration parameter that represents the internal subset, or null if there is no internal subset
`String` `getKind()` Returns the document type kind (PUBLIC or SYSTEM)
`DTDDeclParameter` `getKindNode()` Returns the node where document type kind (PUBLIC or SYSTEM) is declared
`String` `getNodeName()`
`short` `getNodeType()`
`NamedNodeMap` `getNotations()`
`DOMDocumentType` `getOwnerDocType()`
`String` `getPublicId()`
`DTDDeclParameter` `getPublicIdNode()`
`String` `getPublicIdWithoutQuotes()`
`String` `getSubstring​(int start, int end)` Returns a substring of the whole document.
`String` `getSystemId()`
`DTDDeclParameter` `getSystemIdNode()`
`String` `getSystemIdWithoutQuotes()`
`String` `getTextContent()`
`boolean` `isInternalSubset​(DTDDeclParameter parameter)`
`void` `setEndInternalSubset​(int end)`
`void` `setStartInternalSubset​(int start)`

### Methods inherited from class org.eclipse.lemminx.dom.DTDDeclNode

`addNewParameter, getDeclType, getName, getNameParameter, getParameterAtIndex, getParameters, getReferencedElementNameAt, getUnrecognized, isInNameParameter, setDeclType, setName, setUnrecognized, updateLastParameterEnd`

### Methods inherited from class org.eclipse.lemminx.dom.DOMNode

`addChild, appendChild, cloneNode, compareDocumentPosition, findAttrAt, findAttrAt, findDTDDeclParameterAt, findDTDDeclParameterAt, findNodeAt, findNodeBefore, findNodeOrAttrAt, findTextAt, getAttribute, getAttributeAtIndex, getAttributeNode, getAttributeNode, getAttributeNodes, getAttributes, getBaseURI, getChild, getChildNodes, getChildren, getChildrenWithAttributeValue, getEnd, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOrphanEndElement, getOrphanEndElement, getOwnerDocument, getParentElement, getParentNode, getPrefix, getPreviousNonTextSibling, getPreviousSibling, getStart, getUserData, hasAttribute, hasAttributes, hasChildNodes, insertBefore, isAttribute, isCDATA, isCharacterData, isChildOfOwnerDocument, isClosed, isComment, isDefaultNamespace, isDoctype, isDTDAttListDecl, isDTDElementDecl, isDTDEntityDecl, isDTDNotationDecl, isElement, isEqualNode, isGenericDTDDecl, isIncluded, isIncluded, isOwnerDocument, isProcessingInstruction, isProlog, isSameNode, isSupported, isText, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setAttribute, setAttributeNode, setNodeValue, setPrefix, setTextContent, setUserData, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.w3c.dom.DocumentType

`getName`

### Methods inherited from interface org.w3c.dom.Node

`appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

### Constructor Detail

#### DOMDocumentType

    public DOMDocumentType​(int start,
                           int end)

### Method Detail

#### getOwnerDocType

    public DOMDocumentType getOwnerDocType()

Overrides:
  `getOwnerDocType` in class `DTDDeclNode`

#### getTextContent

    public String getTextContent()

Specified by:
  `getTextContent` in interface `Node`
Overrides:
  `getTextContent` in class `DOMNode`

#### getKind

    public String getKind()

Returns the document type kind (PUBLIC or SYSTEM)

Returns:
  the document type kind (PUBLIC or SYSTEM)

#### getKindNode

    public DTDDeclParameter getKindNode()

Returns the node where document type kind (PUBLIC or SYSTEM) is declared

Returns:
  the node where document type kind (PUBLIC or SYSTEM) is declared

#### getNodeName

    public String getNodeName()

Specified by:
  `getNodeName` in interface `Node`
Overrides:
  `getNodeName` in class `DTDDeclNode`

#### getNodeType

    public short getNodeType()

Specified by:
  `getNodeType` in interface `Node`
Overrides:
  `getNodeType` in class `DTDDeclNode`

#### getEntities

    public NamedNodeMap getEntities()

Specified by:
  `getEntities` in interface `DocumentType`

#### getInternalSubset

    public String getInternalSubset()

Specified by:
  `getInternalSubset` in interface `DocumentType`

#### setStartInternalSubset

    public void setStartInternalSubset​(int start)

#### setEndInternalSubset

    public void setEndInternalSubset​(int end)

#### isInternalSubset

    public boolean isInternalSubset​(DTDDeclParameter parameter)

#### getNotations

    public NamedNodeMap getNotations()

Specified by:
  `getNotations` in interface `DocumentType`

#### getPublicId

    public String getPublicId()

Specified by:
  `getPublicId` in interface `DocumentType`

#### getPublicIdWithoutQuotes

    public String getPublicIdWithoutQuotes()

#### getPublicIdNode

    public DTDDeclParameter getPublicIdNode()

#### getSystemId

    public String getSystemId()

Specified by:
  `getSystemId` in interface `DocumentType`

#### getSystemIdNode

    public DTDDeclParameter getSystemIdNode()

#### getSystemIdWithoutQuotes

    public String getSystemIdWithoutQuotes()

#### getSubstring

    public String getSubstring​(int start,
                               int end)

Returns a substring of the whole document. Since offset values are relative to 'this.start' we need to subtract getStart() to make them relative to 'content'

#### getInternalSubsetNode

    public DTDDeclParameter getInternalSubsetNode()

Returns the declaration parameter that represents the internal subset, or null if there is no internal subset

Returns:
  the declaration parameter that represents the internal subset, or null if there is no internal subset